<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 https://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>
    <parent>
        <groupId>org.springframework.boot</groupId>
        <artifactId>spring-boot-starter-parent</artifactId>
        <version>2.2.8.RELEASE</version>
	<relativePath/>
    </parent>
    <groupId>com.watermyplants</groupId>
    <artifactId>plants</artifactId>
    <version>0.0.1-SNAPSHOT</version>
    <name>plants</name>
    <description>Water-My-Plants project for Spring Boot</description>
     <dependencies>
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-data-jpa</artifactId>
        </dependency>
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-web</artifactId>
        </dependency>
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-validation</artifactId>
        </dependency>
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-devtools</artifactId>
            <scope>runtime</scope>
            <optional>true</optional>
        </dependency>
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-test</artifactId>
            <scope>test</scope>
        </dependency>
        <!-- Swagger Dependencies Start -->
        <!-- https://mvnrepository.com/artifact/io.springfox/springfox-swagger2 -->
        <dependency>
            <groupId>io.springfox</groupId>
            <artifactId>springfox-swagger2</artifactId>
            <version>2.9.2</version>
        </dependency>
        <!-- https://mvnrepository.com/artifact/io.springfox/springfox-swagger-ui -->
        <dependency>
            <groupId>io.springfox</groupId>
            <artifactId>springfox-swagger-ui</artifactId>
            <version>2.9.2</version>
        </dependency>
        <dependency>
            <groupId>io.springfox</groupId>
            <artifactId>springfox-bean-validators</artifactId>
            <version>2.9.2</version>
        </dependency>
        <!-- Swagger Dependencies End -->
        <!-- Security Dependencies Start -->
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-security</artifactId>
        </dependency>

        <dependency>
            <groupId>org.springframework.security</groupId>
            <artifactId>spring-security-test</artifactId>
            <scope>test</scope>
        </dependency>

        <dependency>
            <groupId>org.springframework.security.oauth</groupId>
            <artifactId>spring-security-oauth2</artifactId>
            <version>2.3.6.RELEASE</version>
        </dependency>
        <!-- Security Dependencies End -->
        <!-- Postgres SQL Dependencies Start -->
        <dependency>
            <groupId>org.postgresql</groupId>
            <artifactId>postgresql</artifactId>
            <scope>runtime</scope>
    </dependency>
         <!-- https://mvnrepository.com/artifact/junit/junit -->
         <dependency>
             <groupId>junit</groupId>
             <artifactId>junit</artifactId>
             <version>4.13</version>
             <scope>test</scope>
         </dependency>
        <dependency>
            <groupId>io.rest-assured</groupId>
            <artifactId>spring-mock-mvc</artifactId>
            <version>3.3.0</version>
            <scope>test</scope>
        </dependency>
         <dependency>
             <groupId>com.h2database</groupId>
             <artifactId>h2</artifactId>
             <version>1.4.200</version>
         </dependency>
     </dependencies>
    <repositories>
        <repository>
            <id>maven-group</id>
            <url>http://172.17.0.1:13001/repository/maven-group/</url>
        </repository>
    </repositories>
   <distributionManagement>
     <repository>
	     <id>nexus</id>
	     <name>MasterDevopsTech</name>
	     <url>http://172.17.0.1:13001/repository/java-backed-rest-app-releases/</url>
     </repository>
     <snapshotRepository>
	     <id>nexus</id>
	     <name>MasterDevopsTech</name>
	     <url>http://172.17.0.1:13001/repository/java-backed-rest-app-snapshots/</url>
     </snapshotRepository>
   </distributionManagement>
  <!-- Convert Packaging to .war -->
  <packaging>war</packaging> 
   <build>
     <finalName>water-my-plants</finalName>
     <plugins>
        <plugin>
           <groupId>org.jacoco</groupId>
               <artifactId>jacoco-maven-plugin</artifactId>
           <version>0.8.6</version>
            <executions>
               <execution>
                 <goals>
                <goal>prepare-agent</goal>
                 </goals>
                    </execution>
                <execution>
                  <id>report</id>
                  <phase>prepare-package</phase>
                  <goals>
                 <goal>report</goal>
                </goals>
                </execution>
                 </executions>
           </plugin>
           <plugin>
                <groupId>com.heroku.sdk</groupId>
                <artifactId>heroku-maven-plugin</artifactId>
                <version>3.0.2</version>
                <configuration>
                    <appName>${project.build.finalName}</appName>
                    <includeTarget>false</includeTarget>
                    <includes>
                        <include>${project.build.directory}/${project.build.finalName}.jar</include>
                    </includes>
                    <jdkVersion>${java.version}</jdkVersion>
                    <processTypes>
                        <web>water_my_plants $JAVA_OPTS -Dserver.port=$PORT -jar target/${project.build.finalName}.jar</web>
                    </processTypes>
                </configuration>
        </plugin>
        <plugin>
            <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-surefire-plugin</artifactId>
                <version>2.19.1</version>
                <configuration>
                <testFailureIgnore>true</testFailureIgnore>
                </configuration>
              </plugin>
            <plugin>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-maven-plugin</artifactId>
            </plugin>
        </plugins>
    </build>
</project>
